/***************************************************************
 * stack.c ---- modul of information cluster for stack class   *
 *              (C version)                                    *
 ***************************************************************/

#include <stdio.h> 
#include "stack.h"

/* the sole global variable to define a common structure for Stack class */
struct stack_common CLASS = { (void (*)(struct link_list **top,char element))(push),
			      (char (*)(struct link_list **top))(pop),
			      (void (*)(struct link_list *top)) (show),
			      (struct link_list (*)(struct link_list *top, char element))(scan),
			      (void (*)(struct link_list *top_from,struct link_list **top_to))(copy)};

/* push operation */
void push(struct link_list **top,char element)
{
  struct link_list *tmp;

  tmp = (struct link_list *) malloc(sizeof(struct link_list));

  tmp->value = element;
  tmp->next = *top;
  *top = tmp;

  return;
}

/* pop operation */
char pop(struct link_list **top)
{
  char ch;
  struct link_list *tmp = *top;

  if (*top == NULL) return NULL;

  ch = (*top)->value; 
  *top = (*top)->next;
  free(tmp);

  return ch;
}

/* display on stdout all elements in a stack (in the order from top to bottom) */
void show(struct link_list *top)
{
  char ch;
  struct link_list *tmp = top;  

  while (tmp) {
    putchar(ch = tmp->value);
    tmp = tmp->next;
  };

  return;
}

/* find location on a stack for a specified element */
struct link_list * scan(struct link_list *top, char element)
{
  struct link_list *tmp = top;
  
  while (tmp && (tmp->value != element)) tmp = tmp->next;
  
  return (tmp);
}

/* copy all elements in a stack to another stack */
void copy(struct link_list *top_from, struct link_list **top_to)
{
  struct link_list *tmp_from = top_from, *tmp_to, *tmp;

  if (top_from == *top_to) return; /* return if copy to itself */
  while ((tmp = *top_to) != NULL) {        /* free any space left */
    *top_to = (*top_to)->next;
    free(tmp);
  };

  if (top_from == NULL) 
    return;
  else {
    tmp_to = *top_to = tmp = (struct link_list *) malloc(sizeof(struct link_list));
    tmp_to->value = top_from->value;
    tmp_from = tmp_from->next;
  };

  /* copy elementwise from top to bottom */
  while (tmp_from) {
    tmp->next = tmp_to = (struct link_list *) malloc(sizeof(struct link_list));
    (tmp = tmp_to)->value = tmp_from->value;
    tmp_from = tmp_from->next;
  };
  tmp->next = NULL;

  return;
}
